//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    TM_Period = 10;
extern int    TM_Shift  = 2;

//
//
//
//
//

double SpanA_Buffer[];
double SpanB_Buffer[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   
   SetIndexBuffer(0,SpanB_Buffer); SetIndexLabel(0,"TM_Period+");
   SetIndexBuffer(1,SpanA_Buffer); SetIndexLabel(1,"TM_Period+");
   
      //
      //
      //
      //
      //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame); 
        
        SetIndexShift(0,TM_Shift * timeFrame/Period());  
        SetIndexShift(1,TM_Shift * timeFrame/Period());        
     
      //
      //
      //
      //
      //
     
     IndicatorShortName(timeFrameToString(timeFrame)+"  TrendManager");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { SpanB_Buffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
        double shi    = High[i];
        double slo    = Low[i];
        double sprice = 0;
        if (i >= Bars - TM_Period) continue;
        for (k = 1; k < TM_Period; k++)
        {
           sprice = High[i+k];
           if(shi < sprice) shi  = sprice;
         
           sprice = Low[i+k];
           if(slo  > sprice) slo = sprice;
        }
        
           SpanA_Buffer[i] = (shi + slo)*0.5;
           SpanB_Buffer[i] = SpanA_Buffer[i+TM_Shift];
      }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          SpanB_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TM_Period,TM_Shift,0,y);
          SpanA_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TM_Period,TM_Shift,1,y);
   }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}